Attribute VB_Name = "IcyMetroAdditions"
Public Function XlMajorVersion() As Integer
    'Excel̃o[WĂяo
    VersionText$ = Excel.Application.Version
    '̃W[o[Ŵ݂o
    XlMajorVersion = CInt(Left(VersionText$, InStr(1, VersionText, ".") - 1))
End Function

Public Function SplitXl97(Expression As Variant, Optional Delimiter As Variant, Optional Limit As Long = -1, Optional Compare As VbCompareMethod = vbBinaryCompare) As String()
    'Excel97ɂSplit֐̑
    'limitivf̐jΉƒ
    Dim StartPosition As Long, EndPosition As Long, ArrayIndex As Long
    Dim ArrayBuffer() As String
    
    ReDim ArrayBuffer(0)
    Delimiter = IIf(Delimiter = "", Space(1), Delimiter)
    If InStr(1, Expression, Delimiter) = 0 Then
        ArrayBuffer(0) = Expression
    Else
        'ϐ̏
        EndPosition = 0
        ArrayIndex = 0
        Do
            StartPosition = EndPosition + 1
            If Compare = vbBinaryCompare Then
                If XlMajorVersion >= 7 Then
                    StartPosition = Fix(StartPosition / 2) * 2 + 1 'Office97`Office98forMacł́Ałɂ
                End If
                EndPosition = InStrB(StartPosition, Expression, Delimiter, vbBinaryCompare)
            Else
                EndPosition = InStr(StartPosition, Expression, Delimiter, Compare)
            End If
            If ArrayIndex > UBound(ArrayBuffer) Then
                ReDim Preserve ArrayBuffer(ArrayIndex)
            End If
            If EndPosition = 0 Or Limit >= ArrayIndex Then
                If Compare = vbBinaryCompare Then
                    ArrayBuffer(ArrayIndex) = RightB(Expression, LenB(Expression) - StartPosition + 1)
                Else
                    ArrayBuffer(ArrayIndex) = Right(Expression, Len(Expression) - StartPosition + 1)
                End If
                Exit Do
            Else
                ArrayBuffer(ArrayIndex) = IIf(Compare = vbBinaryCompare, MidB(Expression, StartPosition, EndPosition - StartPosition), Mid(Expression, StartPosition, EndPosition - StartPosition))
                ArrayIndex = ArrayIndex + 1
            End If
        Loop
    End If
    SplitXl97 = ArrayBuffer
End Function

Public Function JoinXl97(SourceArray() As String, Optional Delimiter As String) As String
    'Excel97ɂJoin֐̑
    '؏
    Dim StringBuffer As String
    Delimiter = IIf(Delimiter = "", Space(1), Delimiter)
    For Each s In SourceArray
        StringBuffer = IIf(StringBuffer = "", s, StringBuffer + Delimiter + s)
    Next
    JoinXl97 = StringBuffer
End Function

Public Function FilterXl97(SourceArray() As String, Match As String, Optional Include As Boolean = True, Optional Compare As VbCompareMethod = vbBinaryCompare) As String()
    'Excel97ɂFilter֐̑
    '`T@p
    Dim i As Long, j As Long
    Dim ArrayBuffer() As String, StringBuffer As String
    Dim SourceElement As String, SourceString As String
    Dim MatchString As String
    
    If Match = "" Then
        FilterXl97 = SourceArray
        Exit Function
    End If
    
    StringBuffer = ""
    For i = LBound(SourceArray) To UBound(SourceArray)
        If Compare = vbBinaryCompare Then
            If XlMajorVersion >= 7 Then
                SourceElement = SourceArray(i)
                SourceString = StrConv(SourceElement, vbFromUnicode)
                MatchString = StrConv(Match, vbFromUnicode)
            Else
                SourceString = SourceArray(i)
                MatchString = Match
            End If
            If Include = (InStrB(1, SourceString, MatchString, Compare) > 0) Then
                    StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ",") + SourceArray(i)
                End If
            Else
                If InStrB(1, SourceString, MatchString, Compare) = 0 Then
                    StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ",") + SourceArray(i)
                End If
            End If
        Else
            If Include = (InStr(1, SourceArray(i), Match, Compare) > 0) Then
                    StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ",") + SourceArray(i)
                End If
            Else
                If InStr(1, SourceArray(i), Match, Compare) = 0 Then
                    StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ",") + SourceArray(i)
                End If
            End If
        End If
    Next
    ArrayBuffer = SplitXl97(StringBuffer, ",", -1, Compare)
    FilterXl97 = ArrayBuffer
End Function
