Attribute VB_Name = "WorksheetsFilter"
'(c)2005-2008, Icy Metropolitan Software

Public Function GetWorksheetsList(SheetsLookedUp As Sheets, Optional NameWith As String, Optional ByVal NameWithout As String = "", Optional Separator As String = ";", Optional LookAt As XlLookAt, Optional Compare As VbCompareMethod = vbBinaryCompare) As String()
Attribute GetWorksheetsList.VB_ProcData.VB_Invoke_Func = " \n14"
    'Cӂ̃ubNŃV[gzSplittedArrayɗ
    'GetThisWorksheetsList\bhVer.3Ŕp~B̊֐SheetsLookedUpThisWorksheet.sheetsݒ肵ĂB
    Dim s As Worksheet
    Dim i As Long
    Dim ArrayBuffer() As String, ArrayBuffer2() As String
    'NameWithoutvp̔zϐ
    
    On Error GoTo ErrorHandling

    ReDim ArrayBuffer(SheetsLookedUp.Count - 1)
    i = -1
    For Each s In SheetsLookedUp
       i = i + 1
       ArrayBuffer(i) = s.Name
    Next
    ArrayBuffer2 = SearchStringArray(ArrayBuffer, NameWith, NameWithout, Separator, LookAt, Compare)
    GetWorksheetsList = ArrayBuffer2
    Exit Function
ErrorHandling:
    If Err.Number = 13 Then
        Resume
    Else
        ReDim ArrayBuffer(0)
        ArrayBuffer(0) = ""
        GetWorksheetsList = ArrayBuffer
    End If
End Function

Public Function InStrOfSheets(What As String, Optional Compare As VbCompareMethod = vbBinaryCompare) As String()
Attribute InStrOfSheets.VB_ProcData.VB_Invoke_Func = " \n14"
    '̌t܂ރ[NV[g񋓂
    Dim ListedName As String
    Dim ArrayList As Variant
    Dim s As Worksheet
    Dim ArrayBuffer() As String
    On Error GoTo ErrorHandling
    
    For Each s In ThisWorkbook.Worksheets
        If Not (s.Cells.Find(What:=What) Is Nothing) Then
            ListedName = IIf(ListedName = "", s.Name, ListedName + "," + s.Name)
        End If
    Next
    'V[g̔zɂ(Excel 97Ή)
    '"IcyMetroAdditions"WW[Kv
    If IcyMetroAdditions.XlMajorVersion >= 9 Then
        'Excel 2000ȍ~:Split֐g
        ArrayBuffer = Split(ListedName, ",", -1, Compare)
    Else
        'Excel 97ȑO:ق̋@\ő
        ArrayBuffer = SplitXl97(ListedName, ",", Compare)
    End If
    InStrOfSheets = ArrayBuffer
    Exit Function
ErrorHandling:
    ReDim ArrayBuffer(0)
    ArrayBuffer(0) = ""
    InStrOfSheets = ArrayBuffer
End Function

Public Function SheetNameExists(Name As String, CheckingBook As String) As Boolean
Attribute SheetNameExists.VB_ProcData.VB_Invoke_Func = " \n14"
    'V[g邱Ƃm߂郁\bh
    'Ώ:ThisWorkbook(݂̃[NubN)
    'ɁAG[̂sȐlɎgĂ
    Dim ws As Worksheet
    Dim CheckingWorksheets As Worksheets 'Ver.4.0Œǉ
    
    For Each ws In Workbooks(CheckingBook).Worksheets
        If ws.Name = Name Then
            SheetNameExists = True
            Exit Function
        End If
    Next
    SheetNameExists = False
End Function

Public Sub DeleteWorksheet(Optional NameWithout As String = "")
    '̌t܂܂Ȃ[NV[gׂč폜
    'Ώ:gp̃ubN
    Dim s As Worksheet
    Dim DisplayDeleteDialog As Boolean 'Ver. 2.2Œǉ
    
    'A[g̕\ꎞOFF(Ver. 2.2Œǉ)
    DisplayDeleteDialog = Application.DisplayAlerts
    Application.DisplayAlerts = False
    
    For Each s In ThisWorkbook.Worksheets
        'NameWithouti؂蕶萄jŎw肵[NV[g͖
        'ȂANameWithoutw肵ĂȂꍇAׂĂ폜
        If NameWithout = "" Or InStr(1, NameWithout, s.Name, vbTextCompare) = 0 Then
            '[NV[g폜
            '_CAO\@\͔p~(Ver. 2.1܂łɎR,Ver. 2.2Őɔp~)
            If MsgBox(s.Name + "[NV[g폜܂?", vbYesNo, "[NV[g̍폜") = vbYes Then
                s.Delete
            End If
        End If
    Next
    
    'A[g̕\ɖ߂(Ver. 2.2Œǉ)
    Application.DisplayAlerts = DisplayDeleteDialog
End Sub

Public Function WorksheetNameGenerator(Name As String) As String
Attribute WorksheetNameGenerator.VB_ProcData.VB_Invoke_Func = " \n14"
    'Õ[NV[gƂAvOŔԍB
    Dim i As String
    
    If Not SheetNameExists(Name) Then
        WorksheetNameGenerator = Name
    Else
        'JԂ
        'ԍt(l2)
        i = 2
        While SheetNameExists(Name + " (" + Trim(Str(i)) + ")")
            i = i + 1
        Wend
        WorksheetNameGenerator = Name + " (" + Trim(Str(i)) + ")"
    End If
End Function

Private Function LookInString(Source As String, Optional NameWith As String, Optional NameWithout As String, Optional Compare As VbCompareMethod) As String
    If Compare = vbBinaryCompare Then
        If NameWithout = "" Or InStrB(1, Source, NameWithout) = 0 Then
            'J}؂ŃV[g𒊏o
            If NameWith = "" Or InStrB(1, Source, NameWith) > 0 Then
                LookInString = Source
            End If
        End If
    Else
        If NameWithout = "" Or InStr(1, Source, NameWithout) = 0 Then
            'J}؂ŃV[g𒊏o
            If NameWith = "" Or InStr(1, Source, NameWith) > 0 Then
                LookInString = Source
            End If
        End If
    End If
End Function

Private Function SearchStringArray(StringArray() As String, Optional NameWith As String, Optional ByVal NameWithout As String = "", Optional Separator As String = ";", Optional LookAt As XlLookAt, Optional Compare As VbCompareMethod = vbBinaryCompare) As String()
    'z񂩂ړI̕񂪂vfT
    Dim StringArrayBuffer1() As String, StringBuffer As String
    Dim StringArrayBuffer2() As String, StringArrayBuffer3() As String
    Dim i As Long, j As Long, k As Long
    Dim NameWithArray() As String, NameWithoutArray() As String
    
    On Error GoTo ErrorHandling
    
    StringArrayBuffer1 = StringArray
    
    If IcyMetroAdditions.XlMajorVersion >= 9 Then
        'Excel 2000ȍ~:Split֐g
        NameWithArray = Split(NameWith, Separator, -1, Compare)
        NameWithoutArray = Split(NameWithout, Separator, -1, Compare)
    Else
        'Excel 97ȑO:ق̋@\ő
        NameWithArray = IcyMetroAdditions.SplitXl97(NameWith, Separator, Compare:=Compare)
        NameWithoutArray = IcyMetroAdditions.SplitXl97(NameWithout, Separator, Compare:=Compare)
    End If
    
    '(1)NameWithōi
    If NameWith = "" Then
        StringArrayBuffer2 = StringArrayBuffer1
    Else
        If LookAt = xlWhole Then
            For j = LBound(StringArrayBuffer1) To UBound(StringArrayBuffer1)
                For i = LBound(NameWithArray) To UBound(NameWithArray)
                    If StringArrayBuffer1(j) = NameWithArray(i) Then
                        StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ";") + StringArrayBuffer1(j)
                    End If
                Next
            Next
            If IcyMetroAdditions.XlMajorVersion >= 9 Then
                StringArrayBuffer2 = Split(StringBuffer, ";", -1, Compare)
            Else
                StringArrayBuffer2 = IcyMetroAdditions.SplitXl97(StringBuffer, ";", -1, Compare)
            End If
        Else
            For i = LBound(NameWithArray) To UBound(NameWithArray)
                If IcyMetroAdditions.XlMajorVersion >= 9 Then
                    StringArrayBuffer1 = Filter(StringArrayBuffer1, NameWithArray(i), True, Compare)
                Else
                    StringArrayBuffer1 = IcyMetroAdditions.FilterXl97(StringArrayBuffer1, NameWith, True, Compare)
                End If
            Next
        End If
        StringArrayBuffer2 = StringArrayBuffer1
    End If
    
    '(2)NameWithoutōi
    If NameWithout = "" Then
        StringArrayBuffer3 = StringArrayBuffer2
    Else
        If LookAt = xlWhole Then
            For j = LBound(StringArrayBuffer1) To UBound(StringArrayBuffer1)
                For i = LBound(NameWithArray) To UBound(NameWithArray)
                    If StringArrayBuffer1(j) <> NameWithArray(i) Then
                        StringBuffer = StringBuffer + IIf(StringBuffer = "", "", ";") + StringArrayBuffer1(j)
                    End If
                Next
            Next
            If IcyMetroAdditions.XlMajorVersion >= 9 Then
                StringArrayBuffer3 = Split(StringBuffer, ";", -1, Compare)
            Else
                StringArrayBuffer3 = IcyMetroAdditions.SplitXl97(StringBuffer, ";", -1, Compare)
            End If
        Else
            For i = LBound(NameWithoutArray) To UBound(NameWithoutArray)
                If IcyMetroAdditions.XlMajorVersion >= 9 Then
                    StringArrayBuffer2 = Filter(StringArrayBuffer2, NameWithoutArray(i), False, Compare)
                Else
                    StringArrayBuffer2 = IcyMetroAdditions.FilterXl97(StringArrayBuffer2, NameWithoutArray(i), False, Compare)
                End If
            Next
        End If
        StringArrayBuffer3 = StringArrayBuffer2
    End If
    
    SearchStringArray = StringArrayBuffer3
    Exit Function
ErrorHandling:
    Erase StringArrayBuffer3
    SearchStringArray = StringArrayBuffer3
End Function
